
/*  A Bison parser, made from grammar.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse linuzparse
#define yylex linuzlex
#define yyerror linuzerror
#define yylval linuzlval
#define yychar linuzchar
#define yydebug linuzdebug
#define yynerrs linuznerrs
#define	NOT	257
#define	EQ	258
#define	NEQ	259
#define	OR	260
#define	AND	261
#define	MAINMENU_NAME	262
#define	COMMENT	263
#define	TEXT	264
#define	BOOL	265
#define	HEX	266
#define	INT	267
#define	STRING	268
#define	TRISTATE	269
#define	DEFINE_BOOL	270
#define	DEFINE_HEX	271
#define	DEFINE_INT	272
#define	DEFINE_STRING	273
#define	DEFINE_TRISTATE	274
#define	DEP_BOOL	275
#define	DEP_MBOOL	276
#define	DEP_HEX	277
#define	DEP_INT	278
#define	DEP_STRING	279
#define	DEP_TRISTATE	280
#define	UNSET	281
#define	CHOICE	282
#define	IF	283
#define	THEN	284
#define	ELSE	285
#define	FI	286
#define	MAINMENU_OPTION	287
#define	NEXT_COMMENT	288
#define	ENDMENU	289
#define	UNQUOTED	290
#define	SINGLE_QUOTED	291
#define	DOUBLE_QUOTED	292
#define	ERROR	293

#line 24 "grammar.y"

	// Compiler, shutup
	#define YYDEBUG 0
	#define YYMAXDEPTH 0

	#include <stdlib.h>

	#include <kdebug.h>
	#include <klocale.h>
	#include <kmessagebox.h>

	#include "configparser.h"

	extern "C" { void linuzerror(const char *); }

	using namespace Config;


#line 43 "grammar.y"
typedef union
{
	QString *string;
	QStringList *strings;
	Config::Node *node;
	Config::NodeList *list;
	Config::VariableList *deps;
	Config::ExpressionNode *expr;
} YYSTYPE;
#line 53 "grammar.y"

	extern int linuzlex(YYSTYPE *);
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		178
#define	YYFLAG		-32768
#define	YYNTBASE	44

#define YYTRANSLATE(x) ((unsigned)(x) <= 293 ? yytranslate[x] : 61)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    40,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    41,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    42,     2,    43,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     3,     5,     8,    10,    12,    14,    16,    18,
    20,    22,    24,    26,    28,    32,    36,    40,    45,    51,
    57,    64,    70,    77,    83,    88,    94,    99,   104,   109,
   114,   119,   125,   131,   138,   145,   152,   158,   163,   167,
   173,   182,   191,   203,   215,   221,   227,   231,   238,   242,
   246,   248,   251,   255,   259,   261,   264,   266,   269,   271,
   273,   275
};

static const short yyrhs[] = {    -1,
    45,     0,    46,     0,    45,    46,     0,    40,     0,    47,
     0,    48,     0,    49,     0,    50,     0,    51,     0,    52,
     0,    53,     0,    55,     0,    39,     0,     8,    59,    40,
     0,     9,    59,    40,     0,    10,    59,    40,     0,    11,
    59,    36,    40,     0,    11,    59,    36,    60,    40,     0,
    12,    59,    36,    60,    40,     0,    12,    59,    36,    60,
    60,    40,     0,    13,    59,    36,    60,    40,     0,    13,
    59,    36,    60,    60,    40,     0,    14,    59,    36,    60,
    40,     0,    15,    59,    36,    40,     0,    15,    59,    36,
    60,    40,     0,    16,    36,    60,    40,     0,    17,    36,
    60,    40,     0,    18,    36,    60,    40,     0,    19,    36,
    60,    40,     0,    20,    36,    60,    40,     0,    21,    59,
    36,    57,    40,     0,    22,    59,    36,    57,    40,     0,
    23,    59,    36,    60,    57,    40,     0,    24,    59,    36,
    60,    57,    40,     0,    25,    59,    36,    60,    57,    40,
     0,    26,    59,    36,    57,    40,     0,    26,    59,    36,
    40,     0,    27,    58,    40,     0,    28,    59,    60,    60,
    40,     0,    29,    54,    41,    30,    40,    45,    32,    40,
     0,    29,    54,    40,    30,    40,    45,    32,    40,     0,
    29,    54,    41,    30,    40,    45,    31,    40,    45,    32,
    40,     0,    29,    54,    40,    30,    40,    45,    31,    40,
    45,    32,    40,     0,    54,     7,    42,    56,    43,     0,
    54,     6,    42,    56,    43,     0,    42,    56,    43,     0,
    33,    34,    40,    45,    35,    40,     0,    38,     4,    38,
     0,    38,     5,    38,     0,    38,     0,     3,    56,     0,
    56,     7,    56,     0,    56,     6,    56,     0,    60,     0,
    57,    60,     0,    36,     0,    58,    36,     0,    37,     0,
    38,     0,    59,     0,    36,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   142,   143,   155,   161,   167,   168,   169,   170,   171,   172,
   173,   174,   175,   176,   182,   185,   188,   193,   196,   201,
   205,   211,   215,   221,   225,   228,   235,   238,   241,   244,
   247,   252,   256,   260,   265,   270,   275,   279,   285,   289,
   311,   314,   317,   320,   325,   328,   331,   336,   342,   346,
   350,   353,   356,   359,   363,   368,   373,   378,   384,   385,
   388,   389
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","NOT","EQ",
"NEQ","OR","AND","MAINMENU_NAME","COMMENT","TEXT","BOOL","HEX","INT","STRING",
"TRISTATE","DEFINE_BOOL","DEFINE_HEX","DEFINE_INT","DEFINE_STRING","DEFINE_TRISTATE",
"DEP_BOOL","DEP_MBOOL","DEP_HEX","DEP_INT","DEP_STRING","DEP_TRISTATE","UNSET",
"CHOICE","IF","THEN","ELSE","FI","MAINMENU_OPTION","NEXT_COMMENT","ENDMENU",
"UNQUOTED","SINGLE_QUOTED","DOUBLE_QUOTED","ERROR","'\\n'","';'","'['","']'",
"config","statements","statement","text_statement","ask_statement","define_statement",
"dependent_statement","unset_statement","choice_statement","if_statement","expression_list",
"menu_block","expression","deps","symbols","prompt","word", NULL
};
#endif

static const short yyr1[] = {     0,
    44,    44,    45,    45,    46,    46,    46,    46,    46,    46,
    46,    46,    46,    46,    47,    47,    47,    48,    48,    48,
    48,    48,    48,    48,    48,    48,    49,    49,    49,    49,
    49,    50,    50,    50,    50,    50,    50,    50,    51,    52,
    53,    53,    53,    53,    54,    54,    54,    55,    56,    56,
    56,    56,    56,    56,    57,    57,    58,    58,    59,    59,
    60,    60
};

static const short yyr2[] = {     0,
     0,     1,     1,     2,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     3,     3,     3,     4,     5,     5,
     6,     5,     6,     5,     4,     5,     4,     4,     4,     4,
     4,     5,     5,     6,     6,     6,     5,     4,     3,     5,
     8,     8,    11,    11,     5,     5,     3,     6,     3,     3,
     1,     2,     3,     3,     1,     2,     1,     2,     1,     1,
     1,     1
};

static const short yydefact[] = {     1,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    14,     5,     2,     3,     6,     7,     8,
     9,    10,    11,    12,    13,    59,    60,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    57,     0,     0,     0,
     0,     0,     4,    15,    16,    17,     0,     0,     0,     0,
     0,    62,    61,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    58,    39,     0,     0,    51,     0,
     0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
    25,     0,    27,    28,    29,    30,    31,     0,    55,     0,
     0,     0,     0,    38,     0,     0,    52,     0,     0,     0,
     0,    47,     0,     0,     0,     0,     0,    19,    20,     0,
    22,     0,    24,    26,    32,    56,    33,     0,     0,     0,
    37,    40,    49,    50,    54,    53,     0,     0,     0,     0,
     0,    21,    23,    34,    35,    36,    46,    45,     0,     0,
    48,     0,     0,     0,     0,     0,    42,     0,    41,     0,
     0,     0,     0,    44,    43,     0,     0,     0
};

static const short yydefgoto[] = {   176,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    61,
    35,    90,   108,    58,    73,   109
};

static const short yypact[] = {   270,
    -5,    -5,    -5,    -5,    -5,    -5,    -5,    -5,   -23,   -15,
    -1,     7,    11,    -5,    -5,    -5,    -5,    -5,    -5,    22,
    -5,    17,    28,-32768,-32768,   270,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,    24,    26,    27,
    32,    33,    37,    40,    42,   -18,   -18,   -18,   -18,   -18,
    44,    45,    52,    54,    55,    56,-32768,    -6,   -18,    14,
     9,    59,-32768,-32768,-32768,-32768,    -9,   -18,   -18,   -18,
    49,-32768,-32768,    62,    63,    86,    90,    91,   -18,   -18,
   -18,   -18,   -18,    60,-32768,-32768,   -18,    14,    36,     1,
    98,   100,    15,   102,   270,-32768,   103,   101,   136,   128,
-32768,   135,-32768,-32768,-32768,-32768,-32768,   165,-32768,   202,
   -18,   -18,   -18,-32768,   235,   167,    50,   170,   196,    14,
    14,-32768,    14,    14,   169,   195,   171,-32768,-32768,   201,
-32768,   227,-32768,-32768,-32768,-32768,-32768,   264,   283,   296,
-32768,-32768,-32768,-32768,    50,    50,     3,     5,   270,   270,
   228,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    96,   138,
-32768,   234,   265,   266,   267,   270,-32768,   270,-32768,   204,
   237,   268,   282,-32768,-32768,   330,   335,-32768
};

static const short yypgoto[] = {-32768,
   -89,   -26,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   -49,   -29,-32768,   310,   -45
};


#define	YYLAST		336


static const short yytable[] = {    63,
    74,    75,    76,    77,    78,   127,   120,   121,   120,   121,
   120,   121,    46,    87,    91,    92,    88,    72,    36,    37,
    47,    97,    98,    99,   100,   102,    72,    36,    37,    85,
    96,    36,    37,    86,    48,   111,   112,   113,   117,   118,
   119,   116,    49,   122,   125,   157,    50,   158,    93,    94,
   110,    89,   130,   132,   115,   120,   121,    57,    60,   159,
   160,    62,   136,    64,   136,    65,    66,    67,    68,   136,
   145,   146,    69,   147,   148,    70,   170,    71,   171,    79,
    80,   138,   139,   140,    72,    36,    37,    81,   101,    82,
    83,    84,   136,   136,   136,    72,    36,    37,    95,   114,
    63,   103,   104,     1,     2,     3,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,   105,   162,   163,    23,   106,
   107,   126,    63,    63,    24,    25,    72,    36,    37,   123,
   129,   124,   128,    63,    63,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,   133,   164,   165,
    23,    72,    36,    37,   134,   131,    24,    25,     1,     2,
     3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    72,    36,    37,    23,   135,   151,   142,   143,   149,    24,
    25,     1,     2,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,   144,   150,   172,    23,    72,    36,    37,
   152,   137,    24,    25,     1,     2,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,   153,   161,   173,    23,
    72,    36,    37,   166,   141,    24,    25,     1,     2,     3,
     4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    72,
    36,    37,    23,   154,   167,   168,   169,   174,    24,    25,
    38,    39,    40,    41,    42,    43,    44,    45,    72,    36,
    37,   175,   155,    51,    52,    53,    54,    55,    56,   177,
    59,    72,    36,    37,   178,   156
};

static const short yycheck[] = {    26,
    46,    47,    48,    49,    50,    95,     6,     7,     6,     7,
     6,     7,    36,    59,     6,     7,     3,    36,    37,    38,
    36,    67,    68,    69,    70,    71,    36,    37,    38,    36,
    40,    37,    38,    40,    36,    81,    82,    83,    88,     4,
     5,    87,    36,    43,    30,    43,    36,    43,    40,    41,
    80,    38,    98,    99,    84,     6,     7,    36,    42,   149,
   150,    34,   108,    40,   110,    40,    40,    36,    36,   115,
   120,   121,    36,   123,   124,    36,   166,    36,   168,    36,
    36,   111,   112,   113,    36,    37,    38,    36,    40,    36,
    36,    36,   138,   139,   140,    36,    37,    38,    40,    40,
   127,    40,    40,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
    25,    26,    27,    28,    29,    40,    31,    32,    33,    40,
    40,    30,   159,   160,    39,    40,    36,    37,    38,    42,
    40,    42,    40,   170,   171,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    40,    31,    32,
    33,    36,    37,    38,    40,    40,    39,    40,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    36,    37,    38,    33,    40,    35,    40,    38,    40,    39,
    40,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    38,    40,    32,    33,    36,    37,    38,
    40,    40,    39,    40,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    24,    25,    26,    27,    28,    29,    40,    40,    32,    33,
    36,    37,    38,    40,    40,    39,    40,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    24,    25,    26,    27,    28,    29,    36,
    37,    38,    33,    40,    40,    40,    40,    40,    39,    40,
     1,     2,     3,     4,     5,     6,     7,     8,    36,    37,
    38,    40,    40,    14,    15,    16,    17,    18,    19,     0,
    21,    36,    37,    38,     0,    40
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 142 "grammar.y"
{ Parser::self()->setRoot(0); ;
    break;}
case 2:
#line 143 "grammar.y"
{
		MainMenuNameNode *menu = 0;
		for (yyvsp[0].list->first(); yyvsp[0].list->current(); yyvsp[0].list->next())
			if (yyvsp[0].list->current()->type() == Node::MainMenuName)
			{
				menu = static_cast<MainMenuNameNode *>(yyvsp[0].list->take());
				break;
			}
		Parser::self()->setRoot(new RootNode(menu, yyvsp[0].list));
	;
    break;}
case 3:
#line 155 "grammar.y"
{
		yyval.list = new NodeList;
		yyval.list->setAutoDelete(true);
		if (yyvsp[0].node)
			yyval.list->append(yyvsp[0].node);
	;
    break;}
case 4:
#line 161 "grammar.y"
{
		if (yyvsp[0].node)
			yyvsp[-1].list->append(yyvsp[0].node);
	;
    break;}
case 5:
#line 167 "grammar.y"
{ yyval.node = 0; ;
    break;}
case 6:
#line 168 "grammar.y"
{ ;
    break;}
case 7:
#line 169 "grammar.y"
{ ;
    break;}
case 8:
#line 170 "grammar.y"
{ ;
    break;}
case 9:
#line 171 "grammar.y"
{ ;
    break;}
case 10:
#line 172 "grammar.y"
{ ;
    break;}
case 11:
#line 173 "grammar.y"
{ ;
    break;}
case 12:
#line 174 "grammar.y"
{ ;
    break;}
case 13:
#line 175 "grammar.y"
{ ;
    break;}
case 14:
#line 176 "grammar.y"
{
		Parser::self()->addError(*yyvsp[0].string);
		delete yyvsp[0].string;
	;
    break;}
case 15:
#line 182 "grammar.y"
{
		yyval.node = new MainMenuNameNode(yyvsp[-1].string);
	;
    break;}
case 16:
#line 185 "grammar.y"
{
		yyval.node = new CommentNode(yyvsp[-1].string);
	;
    break;}
case 17:
#line 188 "grammar.y"
{
		yyval.node = new TextNode(yyvsp[-1].string);
	;
    break;}
case 18:
#line 193 "grammar.y"
{
		yyval.node = new BoolInputNode(yyvsp[-2].string, yyvsp[-1].string);
	;
    break;}
case 19:
#line 196 "grammar.y"
{
		// INVALID (2.4.x)
		yyval.node = new BoolInputNode(yyvsp[-3].string, yyvsp[-2].string);
		delete yyvsp[-1].string;
	;
    break;}
case 20:
#line 201 "grammar.y"
{
		yyval.node = new HexInputNode(yyvsp[-3].string, yyvsp[-2].string,
			new VariableNode(yyvsp[-1].string));
	;
    break;}
case 21:
#line 205 "grammar.y"
{
		// INVALID (2.2.18 at least)
		yyval.node = new HexInputNode(yyvsp[-4].string, yyvsp[-3].string,
			new VariableNode(yyvsp[-1].string));
		delete yyvsp[-2].string;
	;
    break;}
case 22:
#line 211 "grammar.y"
{
		yyval.node = new IntInputNode(yyvsp[-3].string, yyvsp[-2].string,
			new VariableNode(yyvsp[-1].string));
	;
    break;}
case 23:
#line 215 "grammar.y"
{
		// INVALID (2.2.18 at least)
		yyval.node = new IntInputNode(yyvsp[-4].string, yyvsp[-3].string,
			new VariableNode(yyvsp[-1].string));
		delete yyvsp[-2].string;
	;
    break;}
case 24:
#line 221 "grammar.y"
{
		yyval.node = new StringInputNode(yyvsp[-3].string, yyvsp[-2].string,
			new VariableNode(yyvsp[-1].string));
	;
    break;}
case 25:
#line 225 "grammar.y"
{
		yyval.node = new TristateInputNode(yyvsp[-2].string, yyvsp[-1].string);
	;
    break;}
case 26:
#line 228 "grammar.y"
{
		// INVALID (2.4.x)
		yyval.node = new TristateInputNode(yyvsp[-3].string, yyvsp[-2].string);
		delete yyvsp[-1].string;
	;
    break;}
case 27:
#line 235 "grammar.y"
{
		yyval.node = new DefineNode(DefineNode::Bool, yyvsp[-2].string, new VariableNode(yyvsp[-1].string));
	;
    break;}
case 28:
#line 238 "grammar.y"
{
		yyval.node = new DefineNode(DefineNode::Hex, yyvsp[-2].string, new VariableNode(yyvsp[-1].string));
	;
    break;}
case 29:
#line 241 "grammar.y"
{
		yyval.node = new DefineNode(DefineNode::Int, yyvsp[-2].string, new VariableNode(yyvsp[-1].string));
	;
    break;}
case 30:
#line 244 "grammar.y"
{
		yyval.node = new DefineNode(DefineNode::String, yyvsp[-2].string, new VariableNode(yyvsp[-1].string));
	;
    break;}
case 31:
#line 247 "grammar.y"
{
		yyval.node = new DefineNode(DefineNode::Tristate, yyvsp[-2].string, new VariableNode(yyvsp[-1].string));
	;
    break;}
case 32:
#line 252 "grammar.y"
{
		yyval.node = new RestricedBoolInputNode(yyvsp[-3].string, yyvsp[-2].string,
			new DependencyListNode(yyvsp[-1].deps));
	;
    break;}
case 33:
#line 256 "grammar.y"
{
		yyval.node = new BoolInputNode(yyvsp[-3].string, yyvsp[-2].string,
			new DependencyListNode(yyvsp[-1].deps));
	;
    break;}
case 34:
#line 260 "grammar.y"
{
		yyval.node = new HexInputNode(yyvsp[-4].string, yyvsp[-3].string,
			new VariableNode(yyvsp[-2].string),
			new DependencyListNode(yyvsp[-1].deps));
	;
    break;}
case 35:
#line 265 "grammar.y"
{
		yyval.node = new IntInputNode(yyvsp[-4].string, yyvsp[-3].string,
			new VariableNode(yyvsp[-2].string),
			new DependencyListNode(yyvsp[-1].deps));
	;
    break;}
case 36:
#line 270 "grammar.y"
{
		yyval.node = new StringInputNode(yyvsp[-4].string, yyvsp[-3].string,
			new VariableNode(yyvsp[-2].string),
			new DependencyListNode(yyvsp[-1].deps));
	;
    break;}
case 37:
#line 275 "grammar.y"
{
		yyval.node = new TristateInputNode(yyvsp[-3].string, yyvsp[-2].string,
			new DependencyListNode(yyvsp[-1].deps));
	;
    break;}
case 38:
#line 279 "grammar.y"
{
		// INVALID: SuSE kernels
		yyval.node = new TristateInputNode(yyvsp[-2].string, yyvsp[-1].string, 0);
	;
    break;}
case 39:
#line 285 "grammar.y"
{
		yyval.node = new UnsetNode(yyvsp[-1].strings);
	;
    break;}
case 40:
#line 289 "grammar.y"
{
		QStringList choices = QStringList::split(QRegExp("[ \t]+"), *yyvsp[-2].string);
		delete yyvsp[-2].string;
		QStringList labels;
		QStringList symbols;
		int defIndex = 0, i = 0;
		for (QStringList::ConstIterator it = choices.begin();
			it != choices.end();
			++it, ++i)
		{
			labels.append(*it);
			if ((*it).startsWith(*yyvsp[-1].string))
				defIndex = i;
			if (++it != choices.end())
				symbols.append(*it);
			else
				labels.remove(labels.fromLast());
		}
		delete yyvsp[-1].string;
		yyval.node = new ChoiceNode(yyvsp[-3].string, labels, symbols, defIndex);
	;
    break;}
case 41:
#line 311 "grammar.y"
{
		yyval.node = new IfNode(yyvsp[-6].expr, yyvsp[-2].list);
	;
    break;}
case 42:
#line 314 "grammar.y"
{
		yyval.node = new IfNode(yyvsp[-6].expr, yyvsp[-2].list);
	;
    break;}
case 43:
#line 317 "grammar.y"
{
		yyval.node = new IfNode(yyvsp[-9].expr, yyvsp[-5].list, yyvsp[-2].list);
	;
    break;}
case 44:
#line 320 "grammar.y"
{
		yyval.node = new IfNode(yyvsp[-9].expr, yyvsp[-5].list, yyvsp[-2].list);
	;
    break;}
case 45:
#line 325 "grammar.y"
{
		yyval.node = new AndExpressionNode(yyvsp[-4].expr, yyvsp[-1].expr);
	;
    break;}
case 46:
#line 328 "grammar.y"
{
		yyval.node = new OrExpressionNode(yyvsp[-4].expr, yyvsp[-1].expr);
	;
    break;}
case 47:
#line 331 "grammar.y"
{
		yyval.node = yyvsp[-1].expr;
	;
    break;}
case 48:
#line 336 "grammar.y"
{
		yyval.node = new MenuNode(static_cast<CommentNode *>(yyvsp[-2].list->take(0)),
			yyvsp[-2].list);
	;
    break;}
case 49:
#line 342 "grammar.y"
{
		yyval.expr = new EqualityExpressionNode(new VariableNode(yyvsp[-2].string),
			new VariableNode(yyvsp[0].string));
	;
    break;}
case 50:
#line 346 "grammar.y"
{
		yyval.expr = new UnequalityExpressionNode(new VariableNode(yyvsp[-2].string),
			new VariableNode(yyvsp[0].string));
	;
    break;}
case 51:
#line 350 "grammar.y"
{
		yyval.expr = new ImplicitExpressionNode(new VariableNode(yyvsp[0].string));
	;
    break;}
case 52:
#line 353 "grammar.y"
{
		yyval.expr = new NotExpressionNode(yyvsp[0].expr);
	;
    break;}
case 53:
#line 356 "grammar.y"
{
		yyval.expr = new AndExpressionNode(yyvsp[-2].expr, yyvsp[0].expr);
	;
    break;}
case 54:
#line 359 "grammar.y"
{
		yyval.expr = new OrExpressionNode(yyvsp[-2].expr, yyvsp[0].expr);
	;
    break;}
case 55:
#line 363 "grammar.y"
{
		yyval.deps = new VariableList;
		yyval.deps->setAutoDelete(true);
		yyval.deps->append(new VariableNode(yyvsp[0].string));
	;
    break;}
case 56:
#line 368 "grammar.y"
{
		yyvsp[-1].deps->append(new VariableNode(yyvsp[0].string));
	;
    break;}
case 57:
#line 373 "grammar.y"
{
		yyval.strings = new QStringList;
		yyval.strings->append(*yyvsp[0].string);
		delete yyvsp[0].string;
	;
    break;}
case 58:
#line 378 "grammar.y"
{
		yyvsp[-1].strings->append(*yyvsp[0].string);
		delete yyvsp[0].string;
	;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 392 "grammar.y"


void linuzerror(const char *s)
{
	Parser::self()->addError(i18n(s));
}

// vim: ts=4 sw=4 noet
